<!DOCTYPE html>
<html lang="en-GB" xml:lang="en-GB" xmlns="http://www.w3.org/1999/xhtml">
<head>
  <meta charset="utf-8">
  <!--meta http-equiv="Content-Type" content="application/xhtml+xml; charset=utf-8" /-->
  <title>WCAG Syntax Only Bookmarklet</title>
  <meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=yes" />
  <link rel="stylesheet" type="text/css" media="screen" href="../../../css/verdemoderna.css" title="default" />
  <link rel="top" href="../../../index.html" title="Accessibility Works: Home page" />
  <meta name="robots" content="noindex, nofollow" />
</head>
<body>
  <header id="header">
    <h1><span class="h1txt"><abbr>WCAG</abbr> Syntax Only Bookmarklet</span></h1>
  </header>

  <main id="main">
    <p>This page provides an alternative to Steve Faulkner's <a href="https://cdpn.io/pen/debug/VRZdGJ"><abbr>WCAG</abbr> Parsing Bookmarklet</a>.
      For background about the <abbr>WCAG</abbr> syntax only bookmarklet, see <a href="index.html">Understanding and Testing <abbr>WCAG</abbr> 2.1 Success Criterion 4.1.1</a>.
    </p>
    <h2>Instructions</h2>
    <p>To check whether a web page violates <a href="https://www.w3.org/WAI/WCAG21/Understanding/parsing.html">success criterion 4.1.1 from <abbr>WCAG</abbr> 2.1</a>,
      follow the steps below.
    </p>
    <ol class="instructions">
      <li>Get Steve Faulkner's &ldquo;Check serialized <abbr>DOM</abbr> of current page&rdquo; bookmarklet from the page <a href="https://validator.w3.org/nu/about.html#extras">About the Nu Html Checker</a>;
        add it to your bookmarks toolbar.
      </li>
      <li>Add the <a href='javascript:(function(){var removeNg=true;var filterStrings=["tag seen","Stray end tag","Bad start tag","Duplicate ID","first occurrence of ID","Unclosed element","unclosed elements","unquoted attribute value","Duplicate attribute"];var filterRE,root,results,result,resultText,i,cnt=0;filterRE=filterStrings.join("|");root=document.getElementById("results");if(!root){alert("No results container found.");return}results=root.getElementsByTagName("li");for(i=0;i<results.length;i+=1){result=results[i];if(result.className!==""){resultText=(result.innerText!==undefined?result.innerText:result.textContent)+"";if(resultText.match(filterRE)===null){result.style.display="none";result.className=result.className+" christopheNoLike";cnt+=1}else if(removeNg==true){if(resultText.indexOf("not allowed on element")!==-1&&resultText.indexOf("ng-")!==-1&&resultText.indexOf("ng-")<resultText.indexOf("not allowed on element")){result.style.display="none";result.className=result.className+" christopheNoLike";cnt+=1}else if(result.classList.contains("info")&&!result.classList.contains("warning")){result.style.display="none";result.className=result.className+" christopheNoLike";cnt+=1}}}}alert("Filtering complete. "+cnt+" items removed.")})();'>WCAG syntax only</a>
        (<abbr>i.e.</abbr> the preceding link) to your bookmarks toolbar.
      </li>
      <li><p>On the page you want to check, activate the &ldquo;Check serialized <abbr>DOM</abbr> of current page&rdquo; bookmarklet.</p>
        <p>If the page is too long or too complex to be handled by the &ldquo;Check serialized <abbr>DOM</abbr> of current page&rdquo; bookmarklet, open <a href="https://www.tpgi.com/arc-toolkit-v5-released/"><abbr>TPGi</abbr>'s <abbr>ARC</abbr> Toolkit</a>
        in the browser, click the button <b>Other tools</b>, then the button <b>Send selected <abbr>DOM</abbr></b>.
        If you didn't select a specific section, the entire <abbr>DOM</abbr> is sent to the <abbr>W3C</abbr> Validator.</p>
        <p>Since May 2023 (or perhaps earlier), the <abbr>ARC</abbr> Toolkit's <b>Send selected <abbr>DOM</abbr></b> function has not been working properly, which has lead to incorrect <abbr>W3C</abbr> Validator results.
          (As a consequence the <abbr>W3C</abbr> Validator has reported, <q>Element <code>head</code> is missing a required instance of child element <code>title</code></q> and <q>Stray start tag <code>html</code></q>
          on page where the <code>title</code> element was present, even on perfectly valid pages.) As a consequence, the <abbr>DOM</abbr> needs to be copied manually into the validator's text area.<br />
          <ol>
            <li>Open the browser's developer tools (<abbr>e.g.</abbr> Firefox's Inspector or Chrome's DevTools), typically by pressing <kbd>F12</kbd>.</li>
            <li>Put the cursor on the <code>html</code> element, press <kbd>F2</kbd> (as if to edit the <abbr>DOM</abbr>), press <kbd>Ctrl A</kbd> (to select the entire <abbr>DOM</abbr> tree), then press <kbd>Ctrl C</kbd> (to copy the entire tree into working memory).</li>
            <li>Go to the <a href="https://validator.w3.org/#validate_by_input">validator's direct input field</a>, add the doctype (<code>&lt;!DOCTYPE html&gt;</code>) and paste the <abbr>DOM</abbr> below the doctype.</li>
            <li>Press the <b>Check</b> button, wait for the results to be displayed in their entirety, then move the step below.</li> 
          </ol>
        </p>
      </li>
      <li>On the page with the validator's results, activate the &ldquo;<abbr>WCAG</abbr> syntax only&rdquo; bookmarklet.
        The remaining issues are violations of success criterion 4.1.1.
      </li>
      <li>To view the unfiltered validator results again, refresh the page.
    </ol>
    <p>Short <abbr>URL</abbr> for this page: <a href="https://11ways.be/twj64z">https://11ways.be/twj64z</a>.</p>
  </main>

  <footer id="footer">
    <p id="licence">
    <a class="image" rel="license" href="http://creativecommons.org/licenses/by-sa/4.0/"><img alt="Creative Commons License Attribution-ShareAlike" style="border-width:0" src="../../../img/cc-licence-by-sa-88x31.png" /></a>
    <br />
    <a href="https://cstrobbe.gitlab.io/A11yWorks/">Accessibility Works</a>
    by <a href="https://gitlab.com/cstrobbe">Christophe Strobbe</a> is licensed under a
    <a lang="en-US" rel="license" href="http://creativecommons.org/licenses/by-sa/4.0/">Creative Commons Attribution-ShareAlike 4.0 International License</a>.
    </p>
    <p><a href="../../../sitemap.html">Site map</a>.</p>
    <p>You can <a href="https://gitlab.com/cstrobbe/A11yWorks">fork the code</a> on GitLab.</p>
  </footer>
</body>
</html>
